using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using System.Reflection;

namespace HostApp
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
          //this will load the PluginWithTeeChart.dll from the bin release or bin folder
          //Please note teechart.dll should also reside in that folder or be pathed by other means.
          LoadPlugin(@"PluginWithTeeChart.dll");
        }

        private void button2_Click(object sender, EventArgs e)
        {
            //this will load the Plugin.dll from the bin release or bin folder
            LoadPlugin("Plugin.dll");
        }

        void LoadPlugin(string pluginName)
        {
            try
            {
                Debug.WriteLine("Loading plugin assembly " + pluginName);

                Assembly assembly = Assembly.LoadFrom(pluginName);

                string factoryTypeName = "Plugin.FactoryImpl";

                Type t = assembly.GetType(factoryTypeName);
                if (t == null)
                {
                    MessageBox.Show("Type: " + factoryTypeName + " not found in plugin assembly");
                    return;
                }

                PluginShared.Factory factory = (PluginShared.Factory) assembly.CreateInstance(t.ToString());
                System.Windows.Forms.Form f = factory.CreateForm();
                f.ShowDialog();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
        }
    }
}